--Uncomment this block to create the tables to hold WIP audit results
---- Drop & Create the WIP_ADJUSTMENTS_AUDIT table
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[niku].[WIP_ADJUSTMENTS_AUDIT]') AND type in (N'U'))
--DROP TABLE [niku].WIP_ADJUSTMENTS_AUDIT
--GO
--SET ANSI_NULLS ON
--GO
--SET QUOTED_IDENTIFIER ON
--GO
--CREATE TABLE [niku].WIP_ADJUSTMENTS_AUDIT(
--	[update_return_value] [int] NULL,
--	[dAdjustnment_Date] [datetime] NULL,
--	[dTransno] [numeric](18, 0) NULL,
--	[dWIPTransDate] [datetime] NULL,
--	[cWIPClntCode] [nvarchar](100) NULL,
--	[cWIPProjId] [nvarchar](100) NULL,
--	[cWIPCharge_Code] [nvarchar](100) NULL,
--	[cWIPResource_Code] [nvarchar](100) NULL,
--	[cWIPInputType] [nvarchar](48) NULL,
--	[cWIPTransactionClass] [nvarchar](48) NULL,
--	[iTransferStatus] [int] NULL,
--	[iAdjustXactionNo] [numeric](18, 0) NULL,
--	[iAdjustNumber] [numeric](18, 0) NULL,
--	[cOutErrorMessage] [nvarchar](1000) NULL
--) ON [PRIMARY]
--GO

---- Drop & Create the WIP_APPROVALS_AUDIT table
--IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[niku].[WIP_APPROVALS_AUDIT]') AND type in (N'U'))
--DROP TABLE [niku].WIP_APPROVALS_AUDIT
--GO
--SET ANSI_NULLS ON
--GO
--SET QUOTED_IDENTIFIER ON
--GO
--CREATE TABLE [niku].WIP_APPROVALS_AUDIT(
--	[approval_return_value] [int] NULL,
--	[approval_Date] [datetime] NULL,
--	[newwipno_out] [numeric](18, 0) NULL
--) ON [PRIMARY]
--GO

--Clear out the audit results table
DELETE FROM ASU_WIP_ADJUSTMENTS;
DELETE FROM ASU_WIP_APPROVALS;

--Declare variables for Transaction Number and Input Type Code
DECLARE
	@V_TRANSNO	NUMERIC,
	@V_INPUT_TYPE NVARCHAR(48)

BEGIN
	DECLARE TRANS_CUR CURSOR
	LOCAL FAST_FORWARD READ_ONLY FOR

	--Insert the SQL that is specific to your case. In this example, we need to pull all WIP transactions
	--for contactors since the beginning of the year where their input type code != posted rate.
	SELECT
	A.TRANSNO,
	(SELECT PRNAME FROM PRTypeCode WHERE PRID = D.prTypeCodeID) AS CurrentTypeCode
	FROM PPA_WIP A,
		 PPA_WIP_VALUES B,
		 SRM_RESOURCES C,
		 PRJ_RESOURCES D
	WHERE A.TRANSDATE > = '2016-01-01 00:00:00.000'
	and A.RESOURCE_CLASS <> 'Employee'
	AND B.TRANSNO = A.TRANSNO
	AND B.CURRENCY_TYPE = 'BILLING'
	AND C.UNIQUE_NAME = A.RESOURCE_CODE
	AND A.STATUS = 0
	AND D.prid = C.ID
	AND A.INPUT_TYPE != CAST(CAST(B.NATURAL_BILLRATE AS DECIMAL(18,2)) AS NVARCHAR)

	OPEN TRANS_CUR
    FETCH TRANS_CUR INTO @V_TRANSNO, @V_INPUT_TYPE

	IF @@ROWCOUNT = 0
		PRINT 'Warning: No transactions were found for update';
		
	--Declare variables to be used to run the REV_PRC_ADJWIPMODXFERXACTION stored procedure
	DECLARE	@update_return_value int,
			@dWIPTransDate datetime,
			@cWIPClntCode nvarchar(100),
			@cWIPProjId nvarchar(100),
			@cWIPCharge_Code nvarchar(100),
			@cWIPResource_Code nvarchar(100),
			@cWIPInputType nvarchar(48),
			@cWIPTransactionClass nvarchar(48),
			@iTransferStatus int,
			@iAdjustXactionNo numeric(18, 0),
			@iAdjustNumber numeric(18, 0),
			@cOutErrorMessage nvarchar(1000),	
			@approval_return_value int,
			@newwipno_out numeric(18, 0)
	    
		WHILE (@@FETCH_STATUS = 0)
			BEGIN
				-- Execute the WIP adjustment		
				EXEC	@update_return_value = [niku].[REV_PRC_ADJWIPMODXFERXACTION]
						@iTransaction = @V_TRANSNO, -- Transaction number for the mismatched WIP transaction
						@cProjId = NULL,
						@cCharge_Code = NULL,
						@cResource_Code = NULL,
						@cCostKeyLevel6 = NULL,
						@cCostKeyLevel7 = NULL,
						@cInput_Type = @V_INPUT_TYPE,  -- Current resource input type code
						@bOverrideDate = NULL,
						@dXferDate = NULL,
						@bChargeable = NULL,
						@nUnitQty = NULL,
						@nRate = NULL,
						@cNotes = NULL,
						@cTransType = NULL,
						@cTransClass = NULL,
						@cMatlVendorCode = NULL,
						@cMatlPoNumber = NULL,
						@nActualCost = NULL,
						@cAdjType = N'T',     -- Adjustment Type
						@cUserId = NULL,
						@bCalcNewRate = 1,    -- Force the new rate to be calculated
						@dWIPTransDate = @dWIPTransDate OUTPUT,
						@cWIPClntCode = @cWIPClntCode OUTPUT,
						@cWIPProjId = @cWIPProjId OUTPUT,
						@cWIPCharge_Code = @cWIPCharge_Code OUTPUT,
						@cWIPResource_Code = @cWIPResource_Code OUTPUT,
						@cWIPInputType = @cWIPInputType OUTPUT,
						@cWIPTransactionClass = @cWIPTransactionClass OUTPUT,
						@iTransferStatus = @iTransferStatus OUTPUT,
						@iAdjustXactionNo = @iAdjustXactionNo OUTPUT,
						@iAdjustNumber = @iAdjustNumber OUTPUT,
						@cOutErrorMessage = @cOutErrorMessage OUTPUT,
						@cLanguageCode = N'en',
						@rateCurrency = NULL,
						@ActualCostCurrency = NULL,
						@roleCode = NULL,
						@ChangeRole = 0,
						@in_TaskID = NULL,
						@in_userLov1 = NULL,
						@in_userLov2 = NULL,
						@in_expenseType = NULL	

						-- Explicit commit after SP execution
						BEGIN TRANSACTION;
						COMMIT;	
						
						-- Insert adjustment result into the audit table
						INSERT INTO niku.ASU_WIP_ADJUSTMENTS
							SELECT 'Update Return Value' = @update_return_value,
									'Adjustment_Date' = GETDATE(),
									@V_TRANSNO AS N'@V_TRANSNO',
									@dWIPTransDate as N'@dWIPTransDate',
									@cWIPClntCode as N'@cWIPClntCode',
									@cWIPProjId as N'@cWIPProjId',
									@cWIPCharge_Code as N'@cWIPCharge_Code',
									@cWIPResource_Code as N'@cWIPResource_Code',
									@cWIPInputType as N'@cWIPInputType',
									@cWIPTransactionClass as N'@cWIPTransactionClass',
									@iTransferStatus as N'@iTransferStatus',
									@iAdjustXactionNo as N'@iAdjustXactionNo',
									@iAdjustNumber as N'@iAdjustNumber',
									@cOutErrorMessage as N'@cOutErrorMessage';

							-- Explicit commit
							BEGIN TRANSACTION;
							COMMIT;

							-- Execute the WIP adjustment approval
							EXEC @approval_return_value = [niku].[SP_ADJWIPAPPROVELINEITEM]
									@adjustgroupno = @iAdjustNumber,   -- Adjutsed transaction number
									@userid = @cWIPResource_Code,      -- Resource ID for the transaction
									@newwipno_out = @newwipno_out OUTPUT
									
							-- Explicit commit after SP execution
							BEGIN TRANSACTION;
							COMMIT;

							-- Insert adjustment approval result into the audit table
							INSERT into niku.ASU_WIP_APPROVALS		
							SELECT	'Approval Return Value' = @approval_return_value, 'Approval_Date' = GETDATE(),@newwipno_out as N'@newwipno_out'

							-- Explicit commit
							BEGIN TRANSACTION;
							COMMIT;
		
			FETCH TRANS_CUR INTO @V_TRANSNO, @V_INPUT_TYPE
		END --End of While loop
	--Close and Deallocate cursor
	CLOSE TRANS_CUR
    DEALLOCATE TRANS_CUR
END
